/* Definitions of target machine for GNU compiler, for ARM with WINCE-PE obj format.
   Copyright (C) 2003, 2004 Free Software Foundation, Inc.
   Contributed by Nick Clifton <nickc@redhat.com>
   
   This file is part of GCC.

   GCC is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2, or (at your
   option) any later version.

   GCC is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with GCC; see the file COPYING.  If not, write to
   the Free Software Foundation, 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#undef  TARGET_DEFAULT
#define TARGET_DEFAULT	(TARGET_FLAG_NOP_FUN)

#undef  USER_LABEL_PREFIX
#define USER_LABEL_PREFIX ""

#undef  MULTILIB_DEFAULTS
#define MULTILIB_DEFAULTS \
  { "marm", "mlittle-endian", "msoft-float", "mfpu=vfp", "mno-thumb-interwork" }  
#undef  FPUTYPE_DEFAULT
#define FPUTYPE_DEFAULT FPUTYPE_VFP

#undef ASM_SPEC
#define ASM_SPEC "\
%{mbig-endian:-EB} \
%{mlittle-endian:-EL} \
%{mcpu=xscale:-mcpu=iwmmxt; mcpu=*:-mcpu=%*} \
%{march=*:-march=%*} \
%{mapcs-*:-mapcs-%*} \
%(subtarget_asm_float_spec) \
%{mthumb-interwork:-mthumb-interwork} \
%{msoft-float:-mfloat-abi=soft} %{mhard-float:-mfloat-abi=hard} \
%{mfloat-abi=*} %{mfpu=*} \
%(subtarget_extra_asm_spec)"

#undef SUBTARGET_EXTRA_SPECS
#define SUBTARGET_EXTRA_SPECS \
  { "subtarget_asm_float_spec", SUBTARGET_ASM_FLOAT_SPEC },

#undef SUBTARGET_ASM_FLOAT_SPEC
#define SUBTARGET_ASM_FLOAT_SPEC "\
%{!mfpu=*:-mfpu=vfp}"

#define TARGET_OS_CPP_BUILTINS()				\
  do								\
  {								\
      builtin_define ("_M_ARM=1");				\
      builtin_define ("ARM=1");					\
      builtin_define ("__MINGWCE__");				\
      builtin_define ("__MINGW32__");			   	\
      builtin_define ("_WIN32");				\
      builtin_define ("_UNICODE");				\
      builtin_define_std ("WIN32");				\
      builtin_define_std ("UNDER_CE");				\
      builtin_define_std ("UNICODE");				\
  }								\
  while (0)

/* Include in the mingw32 libraries with libgcc */
#undef LINK_SPEC
#define LINK_SPEC "%{shared: %{mdll: %eshared and mdll are not compatible}} \
  %{shared: --shared} %{mdll:--dll} \
  %{shared|mdll: -e _DllMainCRTStartup}"

//  %{static:-Bstatic} %{!static:-Bdynamic} 

#undef  SUBTARGET_CPP_SPEC
#define SUBTARGET_CPP_SPEC "-D__pe__ -Dmain=main2"
